"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ember_cli_entities_1 = require("./lib/utils/ember-cli-entities");
const broccoli_debug_1 = __importDefault(require("broccoli-debug"));
const preprocessor_registry_1 = require("./plugins/preprocessor-registry");
const options_1 = require("./lib/options");
const ember_css_modules_1 = __importDefault(require("./plugins/ember-css-modules"));
const addonPrototype = ember_cli_entities_1.addon({
    name: require(`${__dirname}/../package`).name,
    makeupOptions: undefined,
    parentAddon: undefined,
    get debugTree() {
        return broccoli_debug_1.default.buildDebugCallback(this.name);
    },
    included(includer) {
        this.makeupOptions = options_1.computeOptions(includer.options && includer.options.makeup);
        if (this.belongsToAddon()) {
            this.parentAddon = includer;
        }
        this._super.included.call(this, includer);
    },
    belongsToAddon() {
        return Boolean(this.parent.parent);
    },
    /**
     * Integrate with other CSS processors, like ember-cli-sass.
     *
     * @see https://github.com/ember-cli/ember-cli-preprocess-registry#addon-usage
     */
    setupPreprocessorRegistry(type, registry) {
        preprocessor_registry_1.register(this, type, registry);
    },
    getIntermediateOutputPath() {
        return this.makeupOptions.intermediateOutputPath;
    },
    /**
     * Integrate with ember-css-modules.
     *
     * @see https://github.com/salsify/ember-css-modules/blob/master/docs/PLUGINS.md#plugins
     */
    createCssModulesPlugin(parent) {
        return new ember_css_modules_1.default(parent);
    }
});
exports.default = addonPrototype;
